Index: cpp/frams/neuro/impl/neuroimpl-body-sdk.h
===================================================================
--- cpp/frams/neuro/impl/neuroimpl-body-sdk.h	(revision 904)
+++ cpp/frams/neuro/impl/neuroimpl-body-sdk.h	(revision 907)
@@ -11,5 +11,5 @@
 {
 public:
-	NeuroImpl* makeNew(){ return new NI_Gyro(); } // for NeuroFactory
+	NeuroImpl* makeNew() { return new NI_Gyro(); } // for NeuroFactory
 	int lateinit() { if (!neuro->joint) return 0; simorder = 0; return 1; }
 	void go() { setState(0); }
@@ -21,5 +21,5 @@
 public:
 	double range;
-	NeuroImpl* makeNew(){ return new NI_Touch(); } // for NeuroFactory
+	NeuroImpl* makeNew() { return new NI_Touch(); } // for NeuroFactory
 	int lateinit() { if (!neuro->part) return 0; simorder = 0; return 1; }
 	void go() { setState(0); }
@@ -30,5 +30,5 @@
 {
 public:
-	NeuroImpl* makeNew(){ return new NI_Smell(); } // for NeuroFactory
+	NeuroImpl* makeNew() { return new NI_Smell(); } // for NeuroFactory
 	void go() { setState(0); }
 	int lateinit() { if (!neuro->part) return 0; simorder = 0; return 1; }
@@ -40,5 +40,5 @@
 public:
 	double power, bendrange;
-	NeuroImpl* makeNew(){ return new NI_BendMuscle(); } // for NeuroFactory
+	NeuroImpl* makeNew() { return new NI_BendMuscle(); } // for NeuroFactory
 	NI_BendMuscle() { paramentries = NI_BendMuscle_tab; }
 	int lateinit() { if (!neuro->joint) return 0; simorder = 2; return 1; }
@@ -51,5 +51,5 @@
 public:
 	double power;
-	NeuroImpl* makeNew(){ return new NI_RotMuscle(); } // for NeuroFactory
+	NeuroImpl* makeNew() { return new NI_RotMuscle(); } // for NeuroFactory
 	NI_RotMuscle() { paramentries = NI_RotMuscle_tab; }
 	int lateinit() { if (!neuro->joint) return 0; simorder = 2; return 1; }
@@ -62,5 +62,5 @@
 public:
 	double power;
-	NeuroImpl* makeNew(){ return new NI_RotMuscle(); } // for NeuroFactory
+	NeuroImpl* makeNew() { return new NI_RotMuscle(); } // for NeuroFactory
 	NI_LinearMuscle() { paramentries = NI_RotMuscle_tab; }
 	int lateinit() { if (!neuro->joint) return 0; simorder = 2; return 1; }
@@ -72,5 +72,5 @@
 public:
 	double power;
-	NeuroImpl* makeNew(){ return new NI_Sticky(); } // for NeuroFactory
+	NeuroImpl* makeNew() { return new NI_Sticky(); } // for NeuroFactory
 	int lateinit() { if (!neuro->part) return 0; simorder = 0; return 1; }
 	void go() {}
@@ -80,5 +80,5 @@
 {
 public:
-	NeuroImpl* makeNew(){ return new NI_WaterDetect(); } // for NeuroFactory
+	NeuroImpl* makeNew() { return new NI_WaterDetect(); } // for NeuroFactory
 	int lateinit() { if (!neuro->part) return 0; simorder = 0; return 1; }
 	void go() { setState(0); }
@@ -88,5 +88,5 @@
 {
 public:
-	NeuroImpl* makeNew(){ return new NI_Energy(); } // for NeuroFactory
+	NeuroImpl* makeNew() { return new NI_Energy(); } // for NeuroFactory
 	void go() { setState(0); }
 };
Index: cpp/frams/neuro/impl/neuroimpl-channels.cpp
===================================================================
--- cpp/frams/neuro/impl/neuroimpl-channels.cpp	(revision 904)
+++ cpp/frams/neuro/impl/neuroimpl-channels.cpp	(revision 907)
@@ -20,12 +20,12 @@
 	s = (max(-1.0, min(1.0, s)) + 1.0) / 2.0; // 0..1
 	int i1;
-	i1 = (int)(s*(c - 1)); i1 = max(0, min(i1, c - 2));
+	i1 = (int)(s * (c - 1)); i1 = max(0, min(i1, c - 2));
 	double sw = 1.0 / (c - 1);
-	double s1 = sw*i1;
+	double s1 = sw * i1;
 	double w1 = fabs((s - s1) / sw);
 	double w2 = 1.0 - w1;
 	double is1 = getWeightedInputState(1, i1);
 	double is2 = getWeightedInputState(1, i1 + 1);
-	setState(is1*w2 + is2*w1);
+	setState(is1 * w2 + is2 * w1);
 }
 
Index: cpp/frams/neuro/impl/neuroimpl-channels.h
===================================================================
--- cpp/frams/neuro/impl/neuroimpl-channels.h	(revision 904)
+++ cpp/frams/neuro/impl/neuroimpl-channels.h	(revision 907)
@@ -11,5 +11,5 @@
 {
 public:
-	NeuroImpl* makeNew(){ return new NI_Channelize(); } // for NeuroFactory
+	NeuroImpl* makeNew() { return new NI_Channelize(); } // for NeuroFactory
 	void go();
 };
@@ -18,5 +18,5 @@
 {
 public:
-	NeuroImpl* makeNew(){ return new NI_ChMux(); } // for NeuroFactory
+	NeuroImpl* makeNew() { return new NI_ChMux(); } // for NeuroFactory
 	void go();
 };
@@ -29,5 +29,5 @@
 	int ch; // channel
 	NI_ChSel() :ch(0) { paramentries = NI_ChSel_tab; }
-	NeuroImpl* makeNew(){ return new NI_ChSel(); } // for NeuroFactory
+	NeuroImpl* makeNew() { return new NI_ChSel(); } // for NeuroFactory
 	void go();
 };
@@ -35,3 +35,2 @@
 
 #endif
-
Index: cpp/frams/neuro/impl/neuroimpl-fuzzy.cpp
===================================================================
--- cpp/frams/neuro/impl/neuroimpl-fuzzy.cpp	(revision 904)
+++ cpp/frams/neuro/impl/neuroimpl-fuzzy.cpp	(revision 907)
@@ -105,5 +105,5 @@
 		nrIn = rulesDef[2 * i]; // nr of inputs in rule #i
 		minimumCut = 2; // the highest value of membership function is 1.0, so this value will definitely change
-		for (j = 0; (j < nrIn) && (minimumCut>0); j++) //minimumCut can not be <0, so if =0 then stop calculations
+		for (j = 0; (j < nrIn) && (minimumCut > 0); j++) //minimumCut can not be <0, so if =0 then stop calculations
 		{
 			nrFuzzySet = rules[i][j * 2 + 1]; // j*2 moves pointer through each output, +1 moves to nr of fuzzy set
@@ -111,5 +111,5 @@
 			minimumCut = min(minimumCut, TrapeziumFuzz(nrFuzzySet, getWeightedInputState(inputNr))); // value of membership function for this input and given fuzzy set
 		}
-		if ((minimumCut>1) || (minimumCut < 0))
+		if ((minimumCut > 1) || (minimumCut < 0))
 			return 1;
 		defuzzParam[i] = minimumCut;
Index: cpp/frams/neuro/impl/neuroimpl-simple.cpp
===================================================================
--- cpp/frams/neuro/impl/neuroimpl-simple.cpp	(revision 904)
+++ cpp/frams/neuro/impl/neuroimpl-simple.cpp	(revision 907)
@@ -21,5 +21,5 @@
 {
 	double sum = getWeightedInputSum();
-	velocity = force*(sum - istate) + inertia*velocity;
+	velocity = force * (sum - istate) + inertia * velocity;
 	istate += velocity;
 	if (istate > NEURO_MAX) istate = NEURO_MAX;
Index: cpp/frams/neuro/impl/neuroimpl-simple.h
===================================================================
--- cpp/frams/neuro/impl/neuroimpl-simple.h	(revision 904)
+++ cpp/frams/neuro/impl/neuroimpl-simple.h	(revision 907)
@@ -23,5 +23,5 @@
 		paramentries = NI_StdNeuron_tab;
 	}
-	NeuroImpl* makeNew(){ return new NI_StdNeuron(); } // for NeuroFactory
+	NeuroImpl* makeNew() { return new NI_StdNeuron(); } // for NeuroFactory
 	int lateinit();
 	void go();
@@ -37,5 +37,5 @@
 		paramentries = NI_StdUNeuron_tab;
 	}
-	NeuroImpl* makeNew(){ return new NI_StdUNeuron(); } // for NeuroFactory
+	NeuroImpl* makeNew() { return new NI_StdUNeuron(); } // for NeuroFactory
 	void calcOutput();
 };
@@ -44,5 +44,5 @@
 {
 public:
-	NeuroImpl* makeNew(){ return new NI_Const(); } // for NeuroFactory
+	NeuroImpl* makeNew() { return new NI_Const(); } // for NeuroFactory
 	int lateinit()
 	{